Leetcode | K Inverse Pairs Array

来源:互联网 发布:知乎 国际政治 编辑:程序博客网 时间:2024/06/05 09:12

原题链接:https://leetcode.com/problems/k-inverse-pairs-array

题目内容如下:

Given two integers n and k, find how many different arrays consist of numbers from 1 to n such that there are exactly k inverse pairs.

We define an inverse pair as following: For ith and jth element in the array, if i < j and a[i] > a[j] then it’s an inverse pair; Otherwise, it’s not.

Since the answer may be very large, the answer should be modulo 109 + 7.

Example 1:
Input: n = 3, k = 0
Output: 1
Explanation:
Only the array [1,2,3] which consists of numbers from 1 to 3 has exactly 0 inverse pair.

Example 2:
Input: n = 3, k = 1
Output: 2
Explanation:
The array [1,3,2] and [2,1,3] have exactly 1 inverse pair.

Note:
The integer n is in the range [1, 1000] and k is in the range [0, 1000].


由题意我们可以看出,这道题是明显的DP问题,所以找出动态规划方程是问题的关键,从子问题到原问题的就是利用下面这个例子的原理,如下

For example,
if we have some permutation of 1…4

5 x x x x creates 4 new inverse pairs
x 5 x x x creates 3 new inverse pairs

x x x x 5 creates 0 new inverse pairs

所以根据上述原理我们可以得出动态规划方程为

dp[n][k] //represent the number of permutations of (1…n) with k inverse pairs.
dp[i][j] = dp[i-1][j] + dp[i-1][j-1] + dp[i-1][j-2] + ….. +dp[i-1][j - i + 1]


根据上述方程,源代码如下所示:

class Solution {public:    int kInversePairs(int n, int k) {        vector<vector<int>> dp(n+1, vector<int>(k+1));        dp[0][0] = 1;        for(int i = 1; i <= n; ++i){            dp[i][0] = 1;            for(int j = 1; j <= k; ++j){                dp[i][j] = (dp[i][j-1] + dp[i-1][j]) % mod;                if(j - i >= 0){                    dp[i][j] = (dp[i][j] - dp[i-1][j-i] + mod) % mod;                 }            }        }        return dp[n][k];    }private:    const int mod = pow(10, 9) + 7;};
原创粉丝点击